#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <time.h>
#include <ctype.h>
#include <sys/time.h>

struct sockaddr_in serv_addr, cli_addr;
struct hostent *hp;
fd_set descriptoresLectura;
int optval = 1;
unsigned int optlen = sizeof(optval);
char hostname[250];
int readsocks, highsock;
int connectlist[10];
int listnum;
int listnumclient;
int server;
char filename[250];

void do_filename(){
  time_t rawtime;
  time ( &rawtime );
  sprintf(filename, "%s", ctime (&rawtime));
  char delims[] = "\n";
  char *result = NULL;
  result = strtok( filename,delims );
  int i = 0;
  int d = 0;
  while( result != NULL ) {
	if(i == 0){
		sprintf(filename,"%s",result);
		for( d = 0; d < strlen(filename);d++){
			if(filename[d] == ' '){
				filename[d] = '_';
			}
		}
		sprintf(filename,"%s.xml",filename);
	}
	result = strtok( NULL, delims );
	i++;
	}
}

void handler(int signum){
	int fd = 0;
	fprintf(stderr,"%s","error");	
	fd = open(filename, O_WRONLY | O_APPEND,0777);
	write(fd, "</xml>", strlen("</xml>"));
	close(fd);
	exit (EXIT_FAILURE);
}

void do_file(){
	int fd = 0;
	fd = open(filename, O_WRONLY | O_CREAT, 0777);
	write(fd,"<xml>\n",strlen("<xml>\n"));
	close(fd);
}
int new_connection() {
	int listnum;
	int connection;
	int client; 	
	char buffer[250];
	connection = accept(server, NULL, NULL);
	if (connection < 0) {
		fprintf(stderr,"%s","accept");
		exit(EXIT_FAILURE);
	}
	for (listnum = 0; (listnum < 10) && (connection != -1); listnum ++){
		if (connectlist[listnum] == 0) {
			fprintf(stdout,"%s %d %d\n","Connection accepted: \n", connection,listnum);
			connectlist[listnum] = connection;
			listnumclient = listnum;
			int var = recv(connection,buffer,sizeof(buffer),0);
			if ( var < 0 ||strcmp("GET /xml-arduino/protocol HTTP/1.1\n",buffer) == 0) {
				fprintf(stdout, "%s %d %d\n", "\nConnection lost: ",connectlist[listnumclient],listnumclient);
				close(client);
				connectlist[listnumclient] = 0;
			} else {
				int n = send(connection,"GET /xml-arduino/protocol HTTP/1.1\nHost: localhost\n",strlen("GET /xml-arduino/protocol HTTP/1.1\nHost: localhost\n"),0);
				if (n < 0){
					fprintf(stderr,"%s","ERROR writing to socket");
				}
			}
			client = connection;
			connection = -1;
		}
	}
	if (connection != -1) {
		fprintf(stdout,"%s","\nNo room left for new client.\n");
		close(connection);
	}
	return client;
}
void take_data(int client) {
	char buffer[174];    
	char *cur_char;      
	int var;
	/* We don't have datas for to read*/
	var = recv(client,buffer,sizeof(buffer),0);
	if ( var < 0) {
		fprintf(stdout, "%s %d %d\n", "\nConnection lost: ",connectlist[listnumclient],listnumclient);
		close(client);
		connectlist[listnumclient] = 0;
	} else {
		/* We got some data*/
		char value[174];
		sprintf(value, "%s", buffer);
		char delims[] = "\n";
		char *result = NULL;
		result = strtok( value, delims );
		int i = 0;
		int d = 0;
		char results[82];
		while( result != NULL ) {
			if(i == 3){
				for(i = 13; i< strlen(result)-6; i++){
					results[d] = result[i];
					d++;
				}
			}
			result = strtok( NULL, delims );
			i++;
		}
		  time_t rawtime;
		  time ( &rawtime );
		  char temp[250];
		  char hour[250];
		  char date[250];
		  char temp2[250];
		  sprintf(temp, "%s", ctime (&rawtime));
		  char delims2[] = "\n";
	      result = NULL;
		  result = strtok( temp,delims2 );
		  i = 0;
		  printf(results);
		  while( result != NULL ) {
			if(i == 0){
				sprintf(temp,"%s",result);
				char delims3[] = " ";
				char *result = NULL;
				result = strtok( temp,delims3 );
				int d = 0;
				while( result != NULL ) {
					if(d == 3){
						sprintf(hour,"%s",result);
					}else if(d==1){
						sprintf(temp2,"%s",result);
					}else if(d==2){
						sprintf(date,"%s %s",result,temp2);
					}else if(d==4){
						sprintf(date,"%s %s",date,result); 
					}
					result = strtok( NULL, delims3 );
					d++;
				}
			}
			result = strtok( NULL, delims2 );
			i++;
		  }
		int fd = open(filename, O_WRONLY | O_APPEND,0777);
		write(fd, "<entry>\n",strlen("<entry>\n"));
		write(fd, "<hour>",strlen("<hour>"));
		write(fd, hour, strlen(hour));
		write(fd, "</hour>\n",strlen("</hour>\n"));
		write(fd, "<date>", strlen("<date>"));
		write(fd, date,strlen(date));
		write(fd, "</date>\n",strlen("</date>\n"));
		write(fd, results, strlen(results));
		close(fd);
		connectlist[listnumclient] = 0;
		close(client);
	}
}
void read_socks(){
	int client;
	if (FD_ISSET(server,&descriptoresLectura)){
		client = new_connection();
	}
	take_data(client);
}
void program_server(){
	do_filename();
	signal(SIGINT, handler);
	fprintf(stdout,"%s \n","Begin the program");
	gethostname(hostname, sizeof(hostname));
	hp = gethostbyname (hostname);
	server = socket(AF_INET, SOCK_STREAM,0);
	setsockopt(server,SOL_SOCKET, SO_REUSEADDR,&optval,optlen);
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_port = htons(9999);
	memmove (&serv_addr.sin_addr, hp->h_addr, hp->h_length);
	if (bind(server, (struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0){
        fprintf(stderr, "%s", "Error: We can't put the addr or the port");
	}
	highsock = server;
	listen(server,10);
	fprintf(stdout,"%s \n","We put the addr and the port");	
	FD_ZERO (&descriptoresLectura);
    FD_SET (server, &descriptoresLectura);
    for (listnum = 0; listnum < 10; listnum++) {
		if (connectlist[listnum] != 0) {
			FD_SET(connectlist[listnum],&descriptoresLectura);
			if (connectlist[listnum] > highsock)
				highsock = connectlist[listnum];
		}
	}
    fprintf(stdout,"%s \n","We add the server's socket");
	do_file();
	fprintf(stdout,"%s \n","We stay in the while");
	while (1){
		readsocks = select(highsock+1,&descriptoresLectura, (fd_set *) 0,(fd_set *) 0, 0);
	    if (readsocks < 0) {
			perror("select");
			exit(EXIT_FAILURE);
		}if (readsocks == 0) {
			fprintf(stdout, "%s \n", "Nothing ready to read");
		} else{
			read_socks();
		}
	}
}	
void main(){
	program_server();
}

